// Generated from ru/vsu/cs/course3/compiler/parse/Parser.g4 by ANTLR 4.13.2
package ru.vsu.cs.course3.compiler.parse;
import org.antlr.v4.runtime.tree.ParseTreeVisitor;

/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by {@link ParserParser}.
 *
 * @param <T> The return type of the visit operation. Use {@link Void} for
 * operations with no return type.
 */
public interface ParserVisitor<T> extends ParseTreeVisitor<T> {
	/**
	 * Visit a parse tree produced by {@link ParserParser#literal}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitLiteral(ParserParser.LiteralContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#ident}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIdent(ParserParser.IdentContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#params}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitParams(ParserParser.ParamsContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#call}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCall(ParserParser.CallContext ctx);
	/**
	 * Visit a parse tree produced by the {@code groupDefault}
	 * labeled alternative in {@link ParserParser#group}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitGroupDefault(ParserParser.GroupDefaultContext ctx);
	/**
	 * Visit a parse tree produced by the {@code groupRule}
	 * labeled alternative in {@link ParserParser#group}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitGroupRule(ParserParser.GroupRuleContext ctx);
	/**
	 * Visit a parse tree produced by the {@code exprDefault}
	 * labeled alternative in {@link ParserParser#expr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprDefault(ParserParser.ExprDefaultContext ctx);
	/**
	 * Visit a parse tree produced by the {@code binOpRule}
	 * labeled alternative in {@link ParserParser#expr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitBinOpRule(ParserParser.BinOpRuleContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#type}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitType(ParserParser.TypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#varDecl}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVarDecl(ParserParser.VarDeclContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#varsDecl}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVarsDecl(ParserParser.VarsDeclContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#paramDecl}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitParamDecl(ParserParser.ParamDeclContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#funcDecl}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitFuncDecl(ParserParser.FuncDeclContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#assign}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAssign(ParserParser.AssignContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#stmt1}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStmt1(ParserParser.Stmt1Context ctx);
	/**
	 * Visit a parse tree produced by the {@code compoundRule}
	 * labeled alternative in {@link ParserParser#stmt2}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCompoundRule(ParserParser.CompoundRuleContext ctx);
	/**
	 * Visit a parse tree produced by the {@code ifRule}
	 * labeled alternative in {@link ParserParser#stmt2}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIfRule(ParserParser.IfRuleContext ctx);
	/**
	 * Visit a parse tree produced by the {@code whileRule}
	 * labeled alternative in {@link ParserParser#stmt2}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWhileRule(ParserParser.WhileRuleContext ctx);
	/**
	 * Visit a parse tree produced by the {@code forRule}
	 * labeled alternative in {@link ParserParser#stmt2}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitForRule(ParserParser.ForRuleContext ctx);
	/**
	 * Visit a parse tree produced by the {@code stmt2Default}
	 * labeled alternative in {@link ParserParser#stmt2}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStmt2Default(ParserParser.Stmt2DefaultContext ctx);
	/**
	 * Visit a parse tree produced by the {@code stmtRule}
	 * labeled alternative in {@link ParserParser#stmt}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStmtRule(ParserParser.StmtRuleContext ctx);
	/**
	 * Visit a parse tree produced by the {@code stmtDefault}
	 * labeled alternative in {@link ParserParser#stmt}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStmtDefault(ParserParser.StmtDefaultContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#stmtList}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitStmtList(ParserParser.StmtListContext ctx);
	/**
	 * Visit a parse tree produced by {@link ParserParser#program}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProgram(ParserParser.ProgramContext ctx);
}