package ru.vsu.cs.course3.compiler.ast;

import java.util.Arrays;
import java.util.Collection;

public class ReturnNode implements StmtNode {
    private ExprNode result;

    public ReturnNode(ExprNode result) {
        this.result = result;
    }

    @Override
    public Collection<AstNode> childs() {
        return Arrays.asList(result);
    }

    @Override
    public String toString() {
        return "return";
    }

    public ExprNode getResult() {
        return result;
    }
}
